/**** closure/flrheader.P: Prepended automatically by the FLORA compiler ****/

:- compiler_options([xpp_on]).
#include "standard.h"
#include "char_defs.h"

#define  VAR_FPREFIX_BASE  dyn_$_$_flora_
#include "flora_prefix.h"


:- import member/2, ground/1 from basics.

:- import consult/1 from consult.

:- import slash/1 from machine.

:- import fmt_write_string/3 from file_io.

:- import current_predicate/1 from curr_sym.

:- import STD_FPREFIX(loadlist)/1, STD_FPREFIX(dynloadlist)/1, 
	STD_FPREFIX(warning_nl)/2
   from flrutils.

:- import bootstrap_flora/0 from flora.


/****************************************************************************/
:- dynamic VAR_FPREFIX(fd)(_,_,_).
:- dynamic VAR_FPREFIX(mvd)(_,_,_).
:- dynamic VAR_FPREFIX(ifd)(_,_,_).
:- dynamic VAR_FPREFIX(imvd)(_,_,_).
:- dynamic VAR_FPREFIX(isa)(_,_).
:- dynamic VAR_FPREFIX(sub)(_,_).
:- dynamic VAR_FPREFIX(fs)(_,_,_).
:- dynamic VAR_FPREFIX(mvs)(_,_,_).
:- dynamic VAR_FPREFIX(exists)(_).
:- dynamic VAR_FPREFIX(mvd)(_,_).
:- dynamic VAR_FPREFIX(imvd)(_,_).

:- table STD_FPREFIX(fd)/3.
:- table STD_FPREFIX(mvd)/3.
:- table STD_FPREFIX(ifd)/3.
:- table STD_FPREFIX(imvd)/3.
:- table STD_FPREFIX(isa)/2.
:- table STD_FPREFIX(sub)/2.
:- table STD_FPREFIX(fs)/3.
:- table STD_FPREFIX(mvs)/3.

:- table VAR_FPREFIX(fd)/3.
:- table VAR_FPREFIX(mvd)/3.
:- table VAR_FPREFIX(ifd)/3.
:- table VAR_FPREFIX(imvd)/3.
:- table VAR_FPREFIX(isa)/2.
:- table VAR_FPREFIX(sub)/2.
:- table VAR_FPREFIX(fs)/3.
:- table VAR_FPREFIX(mvs)/3.
:- table VAR_FPREFIX(exists)/1.
:- table VAR_FPREFIX(mvd)/2.
:- table VAR_FPREFIX(imvd)/2.

STD_FPREFIX(fd)(O,M,R)   :- VAR_FPREFIX(fd)(O,M,R).
STD_FPREFIX(mvd)(O,M,R)  :- VAR_FPREFIX(mvd)(O,M,R).
STD_FPREFIX(ifd)(O,M,R)  :- VAR_FPREFIX(ifd)(O,M,R).
STD_FPREFIX(imvd)(O,M,R) :- VAR_FPREFIX(imvd)(O,M,R).
STD_FPREFIX(isa)(O1,O2)  :- VAR_FPREFIX(isa)(O1,O2).
STD_FPREFIX(sub)(O1,O2)  :- VAR_FPREFIX(sub)(O1,O2).
STD_FPREFIX(fs)(O,M,R)   :- VAR_FPREFIX(fs)(O,M,R).
STD_FPREFIX(mvs)(O,M,R)  :- VAR_FPREFIX(mvs)(O,M,R).
STD_FPREFIX(exists)(O)   :- VAR_FPREFIX(exists)(O).
STD_FPREFIX(mvd)(O,M)    :- VAR_FPREFIX(mvd)(O,M).
STD_FPREFIX(imvd)(O,M)   :- VAR_FPREFIX(imvd)(O,M).


/****************************************************************************/
STD_FPREFIX(tag)(noquery).

?- STD_FPREFIX(tag)(query), !,
   (   current_predicate(STD_FPREFIX(print_all)/2)
   ;   bootstrap_flora
   ),
   !.


#undef VAR_FPREFIX_BASE

/************************** End of Header ***********************************/

%%%  john[salary@(1990) -> 20].
'_$_$_flora_''fd'(john,'flora_@'(salary,1990),20).


%%% john[salary@(1991) -> 40].
'_$_$_flora_''fd'(john,'flora_@'(salary,1991),40).


%%% john[salary@(1992) -> 60].
'_$_$_flora_''fd'(john,'flora_@'(salary,1992),60).


%%% john[salary@(1993) -> 70].
'_$_$_flora_''fd'(john,'flora_@'(salary,1993),70).


%%% john[salary@(1994) -> 70].
'_$_$_flora_''fd'(john,'flora_@'(salary,1994),70).


%%% john[salary@(1995) -> 80].
'_$_$_flora_''fd'(john,'flora_@'(salary,1995),80).


%%% john[salary@(1996) -> 70].
'_$_$_flora_''fd'(john,'flora_@'(salary,1996),70).


%%% john[salary@(1997) -> 50].
'_$_$_flora_''fd'(john,'flora_@'(salary,1997),50).


%%% john[salary@(1998) -> 80].
'_$_$_flora_''fd'(john,'flora_@'(salary,1998),80).


%%%  mary[salary@(1990) -> 40].
'_$_$_flora_''fd'(mary,'flora_@'(salary,1990),40).


%%% mary[salary@(1991) -> 30].
'_$_$_flora_''fd'(mary,'flora_@'(salary,1991),30).


%%% mary[salary@(1992) -> 60].
'_$_$_flora_''fd'(mary,'flora_@'(salary,1992),60).


%%% mary[salary@(1993) -> 70].
'_$_$_flora_''fd'(mary,'flora_@'(salary,1993),70).


%%% mary[salary@(1994) -> 60].
'_$_$_flora_''fd'(mary,'flora_@'(salary,1994),60).


%%% mary[salary@(1995) -> 60].
'_$_$_flora_''fd'(mary,'flora_@'(salary,1995),60).


%%% mary[salary@(1996) -> 70].
'_$_$_flora_''fd'(mary,'flora_@'(salary,1996),70).


%%% mary[salary@(1997) -> 80].
'_$_$_flora_''fd'(mary,'flora_@'(salary,1997),80).


%%% mary[salary@(1998) -> unknown].
'_$_$_flora_''fd'(mary,'flora_@'(salary,1998),unknown).


%%%  ?- Z := max {X; john[salary@(Year)->X] }.
?- '_$_$_flora_''print_all'(','(findall(_h7851,'_$_$_flora_''fd_rhs'(john,'flora_@'(salary,_h7898),_h7851),_h7993),','('_$_$_flora_''max'(nogrp,_h7993,_h8006),is(_h7830,_h8006))),[var('Z',_h7830),var('X',_h7851),var('Year',_h7898)]).

'_$_$_flora_''tag'(query).


%%%  ?- Z := max{X ; john[salary@(Year) ->X], Year < 1996}.
?- '_$_$_flora_''print_all'(','(findall(_h8676,','('_$_$_flora_''fd_rhs'(john,'flora_@'(salary,_h8723),_h8676),<(_h8723,1996)),_h8872),','('_$_$_flora_''max'(nogrp,_h8872,_h8885),is(_h8655,_h8885))),[var('Z',_h8655),var('X',_h8676),var('Year',_h8723)]).

'_$_$_flora_''tag'(query).


%%%  ?- Z=count{Year; john.salary@(Year) < max{X; john[salary@(Y2)->X], Y2<Year} }.
?- '_$_$_flora_''print_all'(','(findall(_h9753,','('_$_$_flora_''fd_rhs'(john,'flora_@'(salary,_h9753),_h10010),','(findall(_h9824,','('_$_$_flora_''fd_rhs'(john,'flora_@'(salary,_h9869),_h9824),<(_h9869,_h9753)),_h10109),','('_$_$_flora_''max'(nogrp,_h10109,_h10122),<(_h10010,_h10122)))),_h10195),','('_$_$_flora_''count'(nogrp,_h10195,_h10208),=(_h9736,_h10208))),[var('Z',_h9736),var('Year',_h9753),var('X',_h9824),var('Y2',_h9869)]).

'_$_$_flora_''tag'(query).


%%%  ?- Z=count{Year; john.salary@(Year) < mary.salary@(Year)}.
?- '_$_$_flora_''print_all'(','(findall(_h10950,','('_$_$_flora_''fd_rhs'(john,'flora_@'(salary,_h10950),_h11105),','('_$_$_flora_''fd_rhs'(mary,'flora_@'(salary,_h10950),_h11130),<(_h11105,_h11130))),_h11175),','('_$_$_flora_''count'(nogrp,_h11175,_h11188),=(_h10933,_h11188))),[var('Z',_h10933),var('Year',_h10950)]).

'_$_$_flora_''tag'(query).


%%%  ?- Z= avg{X [Who]; Who[salary@(Year)->X]}.
?- '_$_$_flora_''print_all'(','(findall(flora_rslt(_h11774,flora_grp(_h11794)),'_$_$_flora_''fd_rhs'(_h11794,'flora_@'(salary,_h11841),_h11774),_h11954),','('_$_$_flora_''avg'(flora_grp(_h11794),_h11954,_h11967),=(_h11755,_h11967))),[var('Z',_h11755),var('X',_h11774),var('Who',_h11794),var('Year',_h11841)]).

'_$_$_flora_''tag'(query).


%%%  ?- Z= collectset{Year [Who]; Who[salary@(Year) -> X], X < 60}.
?- '_$_$_flora_''print_all'(','(findall(flora_rslt(_h12705,flora_grp(_h12725)),','('_$_$_flora_''fd_rhs'(_h12725,'flora_@'(salary,_h12705),_h12794),<(_h12794,60)),_h12943),','('_$_$_flora_''collectset'(flora_grp(_h12725),_h12943,_h12956),=(_h12686,_h12956))),[var('Z',_h12686),var('Year',_h12705),var('Who',_h12725),var('X',_h12794)]).

'_$_$_flora_''tag'(query).


%%%  ?- retract(mary[salary@(Y)->S],S=unknown).
?- '_$_$_flora_''print_all'('_$_$_flora_''retract'([flora_rtrct('dyn_$_$_flora_''fd'(mary,'flora_@'(salary,_h13556),_h13576)),=(_h13576,unknown)],[]),[var('Y',_h13556),var('S',_h13576)]).

'_$_$_flora_''tag'(query).


%%%  ?- retract(john[salary@(Y)->S1], mary[salary@(Y)->S2], S1<S2).
?- '_$_$_flora_''print_all'('_$_$_flora_''retract'([flora_rtrct('dyn_$_$_flora_''fd'(john,'flora_@'(salary,_h14393),_h14413)),flora_rtrct('dyn_$_$_flora_''fd'(mary,'flora_@'(salary,_h14393),_h14474)),<(_h14413,_h14474)],[]),[var('Y',_h14393),var('S1',_h14413),var('S2',_h14474)]).

'_$_$_flora_''tag'(query).


%%%  ?- retract(john[salary@(Y)->S1] | mary[salary@(Y)->S2], S1<S2).
?- '_$_$_flora_''print_all'('_$_$_flora_''retract'([flora_rtrct('dyn_$_$_flora_''fd'(john,'flora_@'(salary,_h15399),_h15419))],['_$_$_flora_''fd_rhs'(mary,'flora_@'(salary,_h15399),_h15482),<(_h15419,_h15482)]),[var('Y',_h15399),var('S1',_h15419),var('S2',_h15482)]).

'_$_$_flora_''tag'(query).


%%%  

/* File:        flraggregate.P
**    	      	trailer appended automatically by the FLORA compiler
**
** Author(s): Guizhen Yang 
** Contact:   xsb-contact@cs.sunysb.edu
**
** Copyright (C) The Research Foundation of SUNY, 1999
**
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
** 
** $Id: flraggregate.P,v 1.7 1999/11/21 05:52:37 kifer Exp $
** 
*/

:- compiler_options([xpp_on]).


#undef VAR_FPREFIX_BASE
#include "flora_prefix.h"


:- import
	var/1, functor/3, arg/3, telling/1, tell/1, nl/0, writeln/1, number/1
   from standard.

:- import member/2, length/2 from basics.

:- import findall/3, sort/2 from setof.

:- import STD_FPREFIX(warning_nl)/1 from flrutils.


/*****************************************************************************
  rules for aggregates
*****************************************************************************/
VAR_FPREFIX(min)(G,Matches,Min) :-
	( G = nogrp ->
	    Matches=[H|T],
	    VAR_FPREFIX(minaux1)(T,H,Min)

	  ; VAR_FPREFIX(var_exists)(G) ->
	    findall(Grp, member(flora_rslt(_,Grp), Matches), L),
	    sort(L,Groups),
	    member(G,Groups),
	    findall(D, member(flora_rslt(D,G), Matches), DL),
	    DL=[H|T],
	    VAR_FPREFIX(minaux1)(T,H,Min)

	  ;
	    Matches=[flora_rslt(D,_)|T],
	    VAR_FPREFIX(minaux2)(T,D,Min)
	).

VAR_FPREFIX(minaux1)([],X,X).
VAR_FPREFIX(minaux1)([H|T],X,N) :-
	(H @< X
	->  VAR_FPREFIX(minaux1)(T,H,N)
	;   VAR_FPREFIX(minaux1)(T,X,N)
	).

VAR_FPREFIX(minaux2)([],X,X).
VAR_FPREFIX(minaux2)([flora_rslt(D,_)|T],X,N) :-
	(D @< X
	->  VAR_FPREFIX(minaux2)(T,D,N)
	;   VAR_FPREFIX(minaux2)(T,X,N)
	).


/****************************************************************************/
VAR_FPREFIX(max)(G,Matches,Max) :-
	( G = nogrp ->
	    Matches=[H|T],
	    VAR_FPREFIX(maxaux1)(T,H,Max)

	  ; VAR_FPREFIX(var_exists)(G) ->
	    findall(Grp, member(flora_rslt(_,Grp), Matches), L),
	    sort(L,Groups),
	    member(G,Groups),
	    findall(D, member(flora_rslt(D,G), Matches), DL),
	    DL=[H|T],
	    VAR_FPREFIX(maxaux1)(T,H,Max)

	  ;
	    Matches=[flora_rslt(D,_)|T],
	    VAR_FPREFIX(maxaux2)(T,D,Max)
	).

VAR_FPREFIX(maxaux1)([],X,X).
VAR_FPREFIX(maxaux1)([H|T],X,N) :-
	(H @> X
	->  VAR_FPREFIX(maxaux1)(T,H,N)
	;   VAR_FPREFIX(maxaux1)(T,X,N)
	).

VAR_FPREFIX(maxaux2)([],X,X).
VAR_FPREFIX(maxaux2)([flora_rslt(D,_)|T],X,N) :-
	(D @> X
	->  VAR_FPREFIX(maxaux2)(T,D,N)
	;   VAR_FPREFIX(maxaux2)(T,X,N)
	).


/****************************************************************************/
VAR_FPREFIX(sum)(G,Matches,Sum) :-
	( G = nogrp ->
	    VAR_FPREFIX(sumaux1)(Matches,X,Sum,Warning)

	  ; VAR_FPREFIX(var_exists)(G) ->
	    findall(Grp, member(flora_rslt(_,Grp), Matches), L),
	    sort(L,Groups),
	    member(G,Groups),
	    findall(D, member(flora_rslt(D,G), Matches), DL),
	    VAR_FPREFIX(sumaux1)(DL,X,Sum,Warning)

	  ;
	    VAR_FPREFIX(sumaux2)(Matches,X,Sum,Warning), !
	),
	( var(Warning) ->
	    true
	  ;
	    STD_FPREFIX(warning_nl)('discarding non-numeric objects while computing sum')
	).

VAR_FPREFIX(sumaux1)([],X,X,_) :-
	(var(X) -> fail ; true).

VAR_FPREFIX(sumaux1)([H|T],X,N,Warning) :-
	( number(H) ->
	    (var(X) -> S=H ; S is X+H),
	    VAR_FPREFIX(sumaux1)(T,S,N,Warning)

	  ;
	    Warning=warning,
	    VAR_FPREFIX(sumaux1)(T,X,N,_)
	).

VAR_FPREFIX(sumaux2)([],X,X,_) :-
	(var(X) -> fail ; true).

VAR_FPREFIX(sumaux2)([flora_rslt(D,_)|T],X,N,Warning) :-
	( number(D) ->
	    (var(X) -> S=D ; S is X+D),
	    VAR_FPREFIX(sumaux2)(T,S,N,Warning)

	  ;
	    Warning=warning,
	    VAR_FPREFIX(sumaux2)(T,X,N,_)
	).


/****************************************************************************/
VAR_FPREFIX(avg)(G,Matches,Avg) :-
	( G = nogrp ->
	    VAR_FPREFIX(avgaux1)(Matches,X1,X2,Avg,Warning)

	  ; VAR_FPREFIX(var_exists)(G) ->
	    findall(Grp, member(flora_rslt(_,Grp), Matches), L),
	    sort(L,Groups),
	    member(G,Groups),
	    findall(D, member(flora_rslt(D,G), Matches), DL),
	    VAR_FPREFIX(avgaux1)(DL,X1,X2,Avg,Warning)

	  ;
	    VAR_FPREFIX(avgaux2)(L,X1,X2,Avg,Warning)
	),
	( var(Warning) ->
	    true
	  ;
	    STD_FPREFIX(warning_nl)('discarding non-numeric objects while computing average')
	).

VAR_FPREFIX(avgaux1)([],S,N,Avg,_) :-
	(var(S) -> fail ; Avg is S/N).

VAR_FPREFIX(avgaux1)([H|T],X1,X2,Avg,Warning) :-
	( number(H) ->
	    (var(X1) -> S=H, N=1 ; S is X1+H, N is X2+1),
	    VAR_FPREFIX(avgaux1)(T,S,N,Avg,Warning)

	  ;
	    Warning=warning,
	    VAR_FPREFIX(avgaux1)(T,X1,X2,Avg,_)
	).

VAR_FPREFIX(avgaux2)([],S,N,Avg,_) :-
	(var(S) -> fail ; Avg is S/N).

VAR_FPREFIX(avgaux2)([flora_rslt(D,_)|T],X1,X2,Avg,Warning) :-
	( number(D) ->
	    (var(X1) -> S=D, N=1 ; S is X1+D, N is X2+1),
	    VAR_FPREFIX(avgaux2)(T,S,N,Avg,Warning)

	  ;
	    Warning=warning,
	    VAR_FPREFIX(avgaux2)(T,X1,X2,Avg,_)
	).


/****************************************************************************/
VAR_FPREFIX(count)(G,Matches,Count) :-
	( VAR_FPREFIX(var_exists)(G) ->
	    findall(Grp, member(flora_rslt(_,Grp), Matches), L),
	    sort(L,Groups),
	    member(G,Groups),
	    findall(D, member(flora_rslt(D,G), Matches), DL),
	    length(DL,Count)

	  ;
	    length(Matches,Count)
	).


/****************************************************************************/
VAR_FPREFIX(collectset)(G,Matches,Set) :-
	( G = nogrp ->
	    sort(Matches,Set)

	  ; VAR_FPREFIX(var_exists)(G) ->
	    findall(Grp, member(flora_rslt(_,Grp), Matches), L),
	    sort(L,Groups),
	    member(G,Groups),
	    findall(D, member(flora_rslt(D,G), Matches), DL),
	    sort(DL,Set)

	  ;
	    findall(D, member(flora_rslt(D,G), Matches), DL),
	    sort(DL,Set)
	).


/****************************************************************************/
VAR_FPREFIX(collectbag)(G,Matches,Bag) :-
	( G = nogrp ->
	    Bag=Matches

	  ; VAR_FPREFIX(var_exists)(G) ->
	    findall(Grp, member(flora_rslt(_,Grp), Matches), L),
	    sort(L,Groups),
	    member(G,Groups),
	    findall(D, member(flora_rslt(D,G), Matches), Bag)

	  ;
	    findall(D, member(flora_rslt(D,G), Matches), Bag)
	).


/****************************************************************************/
VAR_FPREFIX(var_exists)(X) :- var(X), !.

VAR_FPREFIX(var_exists)(T) :-
	functor(T,_,N),
	VAR_FPREFIX(var_exists)(T,N).

VAR_FPREFIX(var_exists)(T,N) :-
	N>=1,
	arg(N,T,Arg),
	( VAR_FPREFIX(var_exists)(Arg) ->
	    !
	  ;
	    M is N-1,
	    VAR_FPREFIX(var_exists)(T,M)
	).


/***********************  End of flraggregate.P  *********************/
/* File:        flrassert.P
**    	        trailer appended automatically by the FLORA compiler
**
** Author(s): Guizhen Yang 
** Contact:   xsb-contact@cs.sunysb.edu
**
** Copyright (C) The Research Foundation of SUNY, 1999
**
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
** 
** $Id: flrassert.P,v 1.6 1999/11/21 05:52:38 kifer Exp $
** 
*/


:- compiler_options([xpp_on]).

#define  VAR_FPREFIX_BASE  dyn_$_$_flora_
#include "flora_prefix.h"


:- import var/1, call/1 from standard.

:- import clause/2 from assert.

:- import trie_assert/1, trie_retract_nr/1 from tables.


/*****************************************************************************
  rules for assert/retract
*****************************************************************************/
STD_FPREFIX(assert)([]).

STD_FPREFIX(assert)([H|T]) :-
	trie_assert(H),
	STD_FPREFIX(assert)(T).


/****************************************************************************/
STD_FPREFIX(retract)(Gs,Cs) :-
	STD_FPREFIX(prove_goals)(Gs,Fs),
	STD_FPREFIX(prove_conditions)(Cs),
	STD_FPREFIX(check_facts)(Fs),
	STD_FPREFIX(retract_facts)(Fs).


STD_FPREFIX(prove_goals)([],[]).

STD_FPREFIX(prove_goals)([flora_rtrct(G)|Gs],[G|Fs]) :-
	!,
	call(G),
	STD_FPREFIX(prove_goals)(Gs,Fs).

STD_FPREFIX(prove_goals)([G|Gs],Fs) :-
	call(G),
	STD_FPREFIX(prove_goals)(Gs,Fs).


STD_FPREFIX(prove_conditions)([]).

STD_FPREFIX(prove_conditions)([C|Cs]) :-
	call(C),
	!,
	STD_FPREFIX(prove_conditions)(Cs).


STD_FPREFIX(check_facts)([]).

STD_FPREFIX(check_facts)([H|Fs]) :-
	clause(H,true),
	STD_FPREFIX(check_facts)(Fs).


STD_FPREFIX(retract_facts)([]).

STD_FPREFIX(retract_facts)([H|Fs]) :-
	trie_retract_nr((H :- true)),
	STD_FPREFIX(retract_facts)(Fs).


/****************************************************************************/
STD_FPREFIX(retractall)(Gs,Cs) :-
	STD_FPREFIX(retract)(Gs,Cs),
	fail.

STD_FPREFIX(retractall)(_,_).


/****************************************************************************/
STD_FPREFIX(erase)(Gs,Cs) :-
	STD_FPREFIX(prove_goals)(Gs,Fs),
	STD_FPREFIX(prove_conditions)(Cs),
	STD_FPREFIX(check_facts)(Fs),
	STD_FPREFIX(erase_facts)(Fs).


STD_FPREFIX(erase_facts)([]).

STD_FPREFIX(erase_facts)([H|Fs]) :-
	STD_FPREFIX(erase_one_fact)(H),
	STD_FPREFIX(erase_facts)(Fs).


STD_FPREFIX(erase_one_fact)(G) :-
	trie_retract_nr(G),
	( G = VAR_FPREFIX(exists)(O)     -> true
	;   G = VAR_FPREFIX(isa)(O,_)    -> true
	;   G = VAR_FPREFIX(fd)(_,_,O)   -> true
	;   G = VAR_FPREFIX(mvd)(_,_,O)  -> true
	;   G = VAR_FPREFIX(ifd)(_,_,O)  -> true
	;   G = VAR_FPREFIX(imvd)(_,_,O) -> true
	;   G = VAR_FPREFIX(fs)(_,_,O)   -> true
	;   G = VAR_FPREFIX(mvs)(_,_,O)  -> true
	;   NextAction=no
	),
	( NextAction==no ->
	    true

	  ; var(O) ->
	    true
	  ;
	    STD_FPREFIX(erase_object)(O)
	).


STD_FPREFIX(erase_object)(O) :-
	STD_FPREFIX(eraseall)([flora_rtrct(VAR_FPREFIX(exists)(O))],[]),
	STD_FPREFIX(eraseall)([flora_rtrct(VAR_FPREFIX(isa)(O,_))],[]),
	STD_FPREFIX(eraseall)([flora_rtrct(VAR_FPREFIX(sub)(O,_))],[]),
	STD_FPREFIX(eraseall)([flora_rtrct(VAR_FPREFIX(fd)(O,_,_))],[]),
	STD_FPREFIX(eraseall)([flora_rtrct(VAR_FPREFIX(mvd)(O,_,_))],[]),
	STD_FPREFIX(eraseall)([flora_rtrct(VAR_FPREFIX(mvd)(O,_))],[]),
	STD_FPREFIX(eraseall)([flora_rtrct(VAR_FPREFIX(ifd)(O,_,_))],[]),
	STD_FPREFIX(eraseall)([flora_rtrct(VAR_FPREFIX(imvd)(O,_,_))],[]),
	STD_FPREFIX(eraseall)([flora_rtrct(VAR_FPREFIX(imvd)(O,_))],[]),
	STD_FPREFIX(eraseall)([flora_rtrct(VAR_FPREFIX(fs)(O,_,_))],[]),
	STD_FPREFIX(eraseall)([flora_rtrct(VAR_FPREFIX(mvs)(O,_,_))],[]),
	STD_FPREFIX(eraseall)([flora_rtrct(VAR_FPREFIX(mvs)(O,_))],[]).


/****************************************************************************/
STD_FPREFIX(eraseall)(Gs,Cs) :-
	STD_FPREFIX(erase)(Gs,Cs),
	fail.

STD_FPREFIX(eraseall)(_,_).


#undef VAR_FPREFIX_BASE

/****************************  End of flrassert.P  *******************/

/*** closure/flrtrailer0.P: appended automatically by the FLORA compiler
     to STATIC code when equality maintenance is DISABLED 
 ***/


#undef VAR_FPREFIX_BASE
#include "flora_prefix.h"
#include "flora_trailer.h"


/*****************************************************************************
  complementary rules to protect against "undefined" error reported by XSB 
*****************************************************************************/
VAR_FPREFIX(fd)(_,_,_)   :- fail.
VAR_FPREFIX(mvd)(_,_,_)  :- fail.
VAR_FPREFIX(ifd)(_,_,_)  :- fail.
VAR_FPREFIX(imvd)(_,_,_) :- fail.
VAR_FPREFIX(fs)(_,_,_)   :- fail.
VAR_FPREFIX(mvs)(_,_,_)  :- fail.
VAR_FPREFIX(sub)(_,_)    :- fail.
VAR_FPREFIX(isa)(_,_)    :- fail.


/****************************  End of Trailer  ******************************/

