/**** closure/flrheader.P: Prepended automatically by the FLORA compiler ****/

:- compiler_options([xpp_on]).
#include "standard.h"
#include "char_defs.h"

#define  VAR_FPREFIX_BASE  dyn_$_$_flora_
#include "flora_prefix.h"


:- import member/2, ground/1 from basics.

:- import consult/1 from consult.

:- import slash/1 from machine.

:- import fmt_write_string/3 from file_io.

:- import current_predicate/1 from curr_sym.

:- import STD_FPREFIX(loadlist)/1, STD_FPREFIX(dynloadlist)/1, 
	STD_FPREFIX(warning_nl)/2
   from flrutils.

:- import bootstrap_flora/0 from flora.


/****************************************************************************/
:- dynamic VAR_FPREFIX(fd)(_,_,_).
:- dynamic VAR_FPREFIX(mvd)(_,_,_).
:- dynamic VAR_FPREFIX(ifd)(_,_,_).
:- dynamic VAR_FPREFIX(imvd)(_,_,_).
:- dynamic VAR_FPREFIX(isa)(_,_).
:- dynamic VAR_FPREFIX(sub)(_,_).
:- dynamic VAR_FPREFIX(fs)(_,_,_).
:- dynamic VAR_FPREFIX(mvs)(_,_,_).
:- dynamic VAR_FPREFIX(exists)(_).
:- dynamic VAR_FPREFIX(mvd)(_,_).
:- dynamic VAR_FPREFIX(imvd)(_,_).

:- table STD_FPREFIX(fd)/3.
:- table STD_FPREFIX(mvd)/3.
:- table STD_FPREFIX(ifd)/3.
:- table STD_FPREFIX(imvd)/3.
:- table STD_FPREFIX(isa)/2.
:- table STD_FPREFIX(sub)/2.
:- table STD_FPREFIX(fs)/3.
:- table STD_FPREFIX(mvs)/3.

:- table VAR_FPREFIX(fd)/3.
:- table VAR_FPREFIX(mvd)/3.
:- table VAR_FPREFIX(ifd)/3.
:- table VAR_FPREFIX(imvd)/3.
:- table VAR_FPREFIX(isa)/2.
:- table VAR_FPREFIX(sub)/2.
:- table VAR_FPREFIX(fs)/3.
:- table VAR_FPREFIX(mvs)/3.
:- table VAR_FPREFIX(exists)/1.
:- table VAR_FPREFIX(mvd)/2.
:- table VAR_FPREFIX(imvd)/2.

STD_FPREFIX(fd)(O,M,R)   :- VAR_FPREFIX(fd)(O,M,R).
STD_FPREFIX(mvd)(O,M,R)  :- VAR_FPREFIX(mvd)(O,M,R).
STD_FPREFIX(ifd)(O,M,R)  :- VAR_FPREFIX(ifd)(O,M,R).
STD_FPREFIX(imvd)(O,M,R) :- VAR_FPREFIX(imvd)(O,M,R).
STD_FPREFIX(isa)(O1,O2)  :- VAR_FPREFIX(isa)(O1,O2).
STD_FPREFIX(sub)(O1,O2)  :- VAR_FPREFIX(sub)(O1,O2).
STD_FPREFIX(fs)(O,M,R)   :- VAR_FPREFIX(fs)(O,M,R).
STD_FPREFIX(mvs)(O,M,R)  :- VAR_FPREFIX(mvs)(O,M,R).
STD_FPREFIX(exists)(O)   :- VAR_FPREFIX(exists)(O).
STD_FPREFIX(mvd)(O,M)    :- VAR_FPREFIX(mvd)(O,M).
STD_FPREFIX(imvd)(O,M)   :- VAR_FPREFIX(imvd)(O,M).


/****************************************************************************/
STD_FPREFIX(tag)(noquery).

?- STD_FPREFIX(tag)(query), !,
   (   current_predicate(STD_FPREFIX(print_all)/2)
   ;   bootstrap_flora
   ),
   !.


#undef VAR_FPREFIX_BASE

/************************** End of Header ***********************************/

%%%    flora_print_ignore(print(pretty)).
flora_print_ignore(print(pretty)).


%%% flora_print_ignore(ignore(pretty)).
flora_print_ignore(ignore(pretty)).


%%%  flora_prettyprint_class(Class, OutFile) :- tell(OutFile), flora_prettyprint_class(Class), told.
flora_prettyprint_class(_h1675,_h1691) :- 
        tell(_h1691),
        flora_prettyprint_class(_h1675),
        told.


%%%  flora_prettyprint_class(Class) :- flora_pp_immediate_superclasses(Class), flora_prettyprint(Class), X : Class, ground(X),  flora_prettyprint(X), fail.
flora_prettyprint_class(_h3006) :- 
        flora_pp_immediate_superclasses(_h3006),
        flora_prettyprint(_h3006),
        '_$_$_flora_''isa_rhs'(_h3083,_h3006),
        ground(_h3083),
        flora_prettyprint(_h3083),
        fail.


%%%  flora_prettyprint(X) :- flora_pp_immediate_classes(X), flora_pp_write_header(X), flora_pp_write_body_scalar(X), flora_pp_write_body_set(X), writeln('].'), nl.
flora_prettyprint(_h4533) :- 
        flora_pp_immediate_classes(_h4533),
        flora_pp_write_header(_h4533),
        flora_pp_write_body_scalar(_h4533),
        flora_pp_write_body_set(_h4533),
        writeln('].'),
        nl.


%%%  flora_pp_write_header(X) :- atom(X), !, fmt_write('''%s''[', f(X)), nl.
flora_pp_write_header(_h5496) :- 
        atom(_h5496),
        !,
        fmt_write('''%s''[',f(_h5496)),
        nl.


%%% flora_pp_write_header(X) :- is_charlist(X), !, fmt_write('"%s"[',arg(X)), nl.
flora_pp_write_header(_h6388) :- 
        is_charlist(_h6388),
        !,
        fmt_write('"%s"[',arg(_h6388)),
        nl.


%%% flora_pp_write_header(X) :- write(X), writeln('[').
flora_pp_write_header(_h7088) :- 
        write(_h7088),
        writeln('[').


%%%  flora_pp_write_body_scalar(Obj) :- MethLst1 = collectset{ML ; Obj[@M -> _], @M =.. ML}, sort(MethLst1, MethLst2), flora_pp_write_body_scalar1(Obj, MethLst2).
flora_pp_write_body_scalar(_h8458) :- 
        findall(_h8505,','('_$_$_flora_''fd_rhs'(_h8458,_h8544,_h8572),=..(_h8544,['flora_@'|_h8505])),_h8790),
        '_$_$_flora_''collectset'(nogrp,_h8790,_h8803),
        =(_h8484,_h8803),
        sort(_h8484,_h8654),
        flora_pp_write_body_scalar1(_h8458,_h8654).


%%%  flora_pp_write_body_scalar1(_, []).
flora_pp_write_body_scalar1(_h9389,[]).


%%% flora_pp_write_body_scalar1(Obj, [MethInv|MethInvs]) :- MethInv = [M|Args],  flora_print_ignore(M), !,  flora_pp_write_body_scalar1(Obj, MethInvs).
flora_pp_write_body_scalar1(_h10570,[_h10593|_h10605]) :- 
        =(_h10593,[_h10656|_h10668]),
        flora_print_ignore(_h10656),
        !,
        flora_pp_write_body_scalar1(_h10570,_h10605).


%%% flora_pp_write_body_scalar1(Obj, [MethInv|MethInvs]) :- MethInv = [M|Args], @M =.. MethInv, Obj[@M -> Val], write('    '), flora_pp_write_method_invocation(MethInv), write(' -> '), flora_pp_write_value(Val), flora_pp_write_semicolon_maybe(MethInvs), flora_pp_write_body_scalar1(Obj, MethInvs).
flora_pp_write_body_scalar1(_h13064,[_h13087|_h13099]) :- 
        =(_h13087,[_h13150|_h13162]),
        =..(_h13183,['flora_@'|_h13087]),
        '_$_$_flora_''fd_rhs'(_h13064,_h13183,_h13264),
        write('    '),
        flora_pp_write_method_invocation(_h13087),
        write(' -> '),
        flora_pp_write_value(_h13264),
        flora_pp_write_semicolon_maybe(_h13099),
        flora_pp_write_body_scalar1(_h13064,_h13099).


%%%  flora_pp_write_body_set(Obj) :- MethLst1 = collectset{ML ; Obj[@M ->> _], @M =.. ML}, sort(MethLst1, MethLst2), flora_pp_write_body_set1(Obj, MethLst2).
flora_pp_write_body_set(_h15056) :- 
        findall(_h15103,','('_$_$_flora_''mvd_rhs'(_h15056,_h15142,_h15172),=..(_h15142,['flora_@'|_h15103])),_h15396),
        '_$_$_flora_''collectset'(nogrp,_h15396,_h15409),
        =(_h15082,_h15409),
        sort(_h15082,_h15254),
        flora_pp_write_body_set1(_h15056,_h15254).


%%%  flora_pp_write_body_set1(_Obj, []).
flora_pp_write_body_set1(_h15991,[]).


%%% flora_pp_write_body_set1(Obj, [MethInv|MethInvs]) :- MethInv = [M|Args],  flora_print_ignore(M), !,  flora_pp_write_body_set1(Obj, MethInvs).
flora_pp_write_body_set1(_h17136,[_h17159|_h17171]) :- 
        =(_h17159,[_h17222|_h17234]),
        flora_print_ignore(_h17222),
        !,
        flora_pp_write_body_set1(_h17136,_h17171).


%%% flora_pp_write_body_set1(Obj, [MethInv|MethInvs]) :- MethInv = [M|Args], @M =.. MethInv, Vals = collectset{V; Obj[@M ->> V]}, write('    '), flora_pp_write_method_invocation(MethInv), write(' ->> '), flora_pp_write_set(Vals), flora_pp_write_semicolon_maybe(MethInvs), flora_pp_write_body_set1(Obj, MethInvs).
flora_pp_write_body_set1(_h19752,[_h19775|_h19787]) :- 
        =(_h19775,[_h19838|_h19850]),
        =..(_h19871,['flora_@'|_h19775]),
        findall(_h19934,'_$_$_flora_''mvd_rhs'(_h19752,_h19871,_h19934),_h20269),
        '_$_$_flora_''collectset'(nogrp,_h20269,_h20282),
        =(_h19913,_h20282),
        write('    '),
        flora_pp_write_method_invocation(_h19775),
        write(' ->> '),
        flora_pp_write_set(_h19913),
        flora_pp_write_semicolon_maybe(_h19787),
        flora_pp_write_body_set1(_h19752,_h19787).


%%%  flora_pp_write_semicolon_maybe([]) :- nl.
flora_pp_write_semicolon_maybe([]) :- 
        nl.


%%% flora_pp_write_semicolon_maybe([_First| _Rest]) :- writeln(';').
flora_pp_write_semicolon_maybe([_h21723|_h21737]) :- 
        writeln(';').


%%%  flora_pp_write_method_invocation([]).
flora_pp_write_method_invocation([]).


%%% flora_pp_write_method_invocation([Attr]) :- flora_pp_write_value(Attr).
flora_pp_write_method_invocation([_h22773]) :- 
        flora_pp_write_value(_h22773).


%%% flora_pp_write_method_invocation([M, Arg |Args]) :- flora_pp_write_value(M), write('@('), flora_pp_write_value(Arg), flora_pp_write_arglist(Args), write(')').
flora_pp_write_method_invocation([_h24043,_h24059|_h24073]) :- 
        flora_pp_write_value(_h24043),
        write('@('),
        flora_pp_write_value(_h24059),
        flora_pp_write_arglist(_h24073),
        write(')').


%%%  flora_pp_write_arglist([]).
flora_pp_write_arglist([]).


%%% flora_pp_write_arglist([Arg|Rest]) :- write(','), flora_pp_write_value(Arg), flora_pp_write_arglist(Rest).
flora_pp_write_arglist([_h25547|_h25559]) :- 
        write(','),
        flora_pp_write_value(_h25547),
        flora_pp_write_arglist(_h25559).


%%%  flora_pp_write_set(L) :- write('{'), flora_pp_write_set1(L), write('}').
flora_pp_write_set(_h26386) :- 
        write('{'),
        flora_pp_write_set1(_h26386),
        write('}').


%%%  flora_pp_write_set1([]).
flora_pp_write_set1([]).


%%% flora_pp_write_set1([Elt]) :- write(Elt).
flora_pp_write_set1([_h27252]) :- 
        write(_h27252).


%%% flora_pp_write_set1([Elt, Elt2 | Rest]) :- flora_pp_write_value(Elt), write(','), flora_pp_write_set1([Elt2|Rest]).
flora_pp_write_set1([_h28254,_h28270|_h28286]) :- 
        flora_pp_write_value(_h28254),
        write(','),
        flora_pp_write_set1([_h28270|_h28286]).


%%%  flora_pp_write_value(Val) :- atom(Val), !, fmt_write('''%s''', arg(Val)).
flora_pp_write_value(_h29184) :- 
        atom(_h29184),
        !,
        fmt_write('''%s''',arg(_h29184)).


%%% flora_pp_write_value(Val) :- is_charlist(Val), !, fmt_write('"%s"', arg(Val)).
flora_pp_write_value(_h30050) :- 
        is_charlist(_h30050),
        !,
        fmt_write('"%s"',arg(_h30050)).


%%% flora_pp_write_value(Val) :- write(Val).
flora_pp_write_value(_h30648) :- 
        write(_h30648).


%%%  flora_prettyprint_isa(Class) :- flora_pp_immediate_isa(Class), flora_pp_subclasses_isa(Class).
flora_prettyprint_isa(_h31463) :- 
        flora_pp_immediate_isa(_h31463),
        flora_pp_subclasses_isa(_h31463).


%%% flora_prettyprint_isa(Class, File) :- tell(File), flora_prettyprint_isa(Class), told.
flora_prettyprint_isa(_h32291,_h32307) :- 
        tell(_h32307),
        flora_prettyprint_isa(_h32291),
        told.


%%%  flora_pp_immediate_isa(Class) :- X : Class, ground(X), ground(Class),  tnot(flora_in_between_isa(X,Class)), flora_pp_write_value(X), write('		:  '), flora_pp_write_value(Class), nl, fail.
flora_pp_immediate_isa(_h33898) :- 
        '_$_$_flora_''isa_rhs'(_h33923,_h33898),
        ground(_h33923),
        ground(_h33898),
        tnot(flora_in_between_isa(_h33923,_h33898)),
        flora_pp_write_value(_h33923),
        write('		:  '),
        flora_pp_write_value(_h33898),
        nl,
        fail.


%%% flora_pp_immediate_isa(_).
flora_pp_immediate_isa(_h34730).


%%%  :- table flora_in_between_isa/2.
:- table
        flora_in_between_isa/2.


%%% flora_in_between_isa(X,Class) :- X: C1, C1 \= Class, C1::Class.
flora_in_between_isa(_h35628,_h35642) :- 
        '_$_$_flora_''isa_rhs'(_h35628,_h35686),
        \=(_h35686,_h35642),
        '_$_$_flora_''sub_rhs'(_h35686,_h35642).


%%%  flora_pp_subclasses_isa(Class) :- Sub :: Class, Sub \= Class, tnot(flora_in_between_sub(Sub,Class)), flora_pp_isa(Sub), fail.
flora_pp_subclasses_isa(_h36862) :- 
        '_$_$_flora_''sub_rhs'(_h36887,_h36862),
        \=(_h36887,_h36862),
        tnot(flora_in_between_sub(_h36887,_h36862)),
        flora_pp_isa(_h36887),
        fail.


%%% flora_pp_subclasses_isa(_).
flora_pp_subclasses_isa(_h37497).


%%%  :- table flora_in_between_sub/2.
:- table
        flora_in_between_sub/2.


%%% flora_in_between_sub(Sub,Class) :- Sub :: Sub1, Sub \= Sub1, Sub1 \= Class, Sub1 :: Class.
flora_in_between_sub(_h38579,_h38593) :- 
        '_$_$_flora_''sub_rhs'(_h38579,_h38639),
        \=(_h38579,_h38639),
        \=(_h38639,_h38593),
        '_$_$_flora_''sub_rhs'(_h38639,_h38593).


%%%  flora_pp_immediate_classes(Obj) :- Obj : Class, ground(Obj), ground(Class), tnot(flora_in_between_isa(Obj,Class)), flora_pp_write_value(Obj), write('	:  '), flora_pp_write_value(Class), write('.'), nl, fail.
flora_pp_immediate_classes(_h40444) :- 
        '_$_$_flora_''isa_rhs'(_h40444,_h40490),
        ground(_h40444),
        ground(_h40490),
        tnot(flora_in_between_isa(_h40444,_h40490)),
        flora_pp_write_value(_h40444),
        write('	:  '),
        flora_pp_write_value(_h40490),
        write('.'),
        nl,
        fail.


%%% flora_pp_immediate_classes(_Obj).
flora_pp_immediate_classes(_h41373).


%%%  flora_pp_immediate_superclasses(Class) :- Class :: Super, ground(Super), Class \= Super, tnot(flora_in_between_sub(Class,Super)), flora_pp_write_value(Class), write('	:: '), flora_pp_write_value(Super), write('.'), nl, fail.
flora_pp_immediate_superclasses(_h43022) :- 
        '_$_$_flora_''sub_rhs'(_h43022,_h43068),
        ground(_h43068),
        \=(_h43022,_h43068),
        tnot(flora_in_between_sub(_h43022,_h43068)),
        flora_pp_write_value(_h43022),
        write('	:: '),
        flora_pp_write_value(_h43068),
        write('.'),
        nl,
        fail.


%%% flora_pp_immediate_superclasses(_).
flora_pp_immediate_superclasses(_h43971).


%%% 

/* File:        flraggregate.P
**    	      	trailer appended automatically by the FLORA compiler
**
** Author(s): Guizhen Yang 
** Contact:   xsb-contact@cs.sunysb.edu
**
** Copyright (C) The Research Foundation of SUNY, 1999
**
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
** 
** $Id: flraggregate.P,v 1.7 1999/11/21 05:52:37 kifer Exp $
** 
*/

:- compiler_options([xpp_on]).


#undef VAR_FPREFIX_BASE
#include "flora_prefix.h"


:- import
	var/1, functor/3, arg/3, telling/1, tell/1, nl/0, writeln/1, number/1
   from standard.

:- import member/2, length/2 from basics.

:- import findall/3, sort/2 from setof.

:- import STD_FPREFIX(warning_nl)/1 from flrutils.


/*****************************************************************************
  rules for aggregates
*****************************************************************************/
VAR_FPREFIX(min)(G,Matches,Min) :-
	( G = nogrp ->
	    Matches=[H|T],
	    VAR_FPREFIX(minaux1)(T,H,Min)

	  ; VAR_FPREFIX(var_exists)(G) ->
	    findall(Grp, member(flora_rslt(_,Grp), Matches), L),
	    sort(L,Groups),
	    member(G,Groups),
	    findall(D, member(flora_rslt(D,G), Matches), DL),
	    DL=[H|T],
	    VAR_FPREFIX(minaux1)(T,H,Min)

	  ;
	    Matches=[flora_rslt(D,_)|T],
	    VAR_FPREFIX(minaux2)(T,D,Min)
	).

VAR_FPREFIX(minaux1)([],X,X).
VAR_FPREFIX(minaux1)([H|T],X,N) :-
	(H @< X
	->  VAR_FPREFIX(minaux1)(T,H,N)
	;   VAR_FPREFIX(minaux1)(T,X,N)
	).

VAR_FPREFIX(minaux2)([],X,X).
VAR_FPREFIX(minaux2)([flora_rslt(D,_)|T],X,N) :-
	(D @< X
	->  VAR_FPREFIX(minaux2)(T,D,N)
	;   VAR_FPREFIX(minaux2)(T,X,N)
	).


/****************************************************************************/
VAR_FPREFIX(max)(G,Matches,Max) :-
	( G = nogrp ->
	    Matches=[H|T],
	    VAR_FPREFIX(maxaux1)(T,H,Max)

	  ; VAR_FPREFIX(var_exists)(G) ->
	    findall(Grp, member(flora_rslt(_,Grp), Matches), L),
	    sort(L,Groups),
	    member(G,Groups),
	    findall(D, member(flora_rslt(D,G), Matches), DL),
	    DL=[H|T],
	    VAR_FPREFIX(maxaux1)(T,H,Max)

	  ;
	    Matches=[flora_rslt(D,_)|T],
	    VAR_FPREFIX(maxaux2)(T,D,Max)
	).

VAR_FPREFIX(maxaux1)([],X,X).
VAR_FPREFIX(maxaux1)([H|T],X,N) :-
	(H @> X
	->  VAR_FPREFIX(maxaux1)(T,H,N)
	;   VAR_FPREFIX(maxaux1)(T,X,N)
	).

VAR_FPREFIX(maxaux2)([],X,X).
VAR_FPREFIX(maxaux2)([flora_rslt(D,_)|T],X,N) :-
	(D @> X
	->  VAR_FPREFIX(maxaux2)(T,D,N)
	;   VAR_FPREFIX(maxaux2)(T,X,N)
	).


/****************************************************************************/
VAR_FPREFIX(sum)(G,Matches,Sum) :-
	( G = nogrp ->
	    VAR_FPREFIX(sumaux1)(Matches,X,Sum,Warning)

	  ; VAR_FPREFIX(var_exists)(G) ->
	    findall(Grp, member(flora_rslt(_,Grp), Matches), L),
	    sort(L,Groups),
	    member(G,Groups),
	    findall(D, member(flora_rslt(D,G), Matches), DL),
	    VAR_FPREFIX(sumaux1)(DL,X,Sum,Warning)

	  ;
	    VAR_FPREFIX(sumaux2)(Matches,X,Sum,Warning), !
	),
	( var(Warning) ->
	    true
	  ;
	    STD_FPREFIX(warning_nl)('discarding non-numeric objects while computing sum')
	).

VAR_FPREFIX(sumaux1)([],X,X,_) :-
	(var(X) -> fail ; true).

VAR_FPREFIX(sumaux1)([H|T],X,N,Warning) :-
	( number(H) ->
	    (var(X) -> S=H ; S is X+H),
	    VAR_FPREFIX(sumaux1)(T,S,N,Warning)

	  ;
	    Warning=warning,
	    VAR_FPREFIX(sumaux1)(T,X,N,_)
	).

VAR_FPREFIX(sumaux2)([],X,X,_) :-
	(var(X) -> fail ; true).

VAR_FPREFIX(sumaux2)([flora_rslt(D,_)|T],X,N,Warning) :-
	( number(D) ->
	    (var(X) -> S=D ; S is X+D),
	    VAR_FPREFIX(sumaux2)(T,S,N,Warning)

	  ;
	    Warning=warning,
	    VAR_FPREFIX(sumaux2)(T,X,N,_)
	).


/****************************************************************************/
VAR_FPREFIX(avg)(G,Matches,Avg) :-
	( G = nogrp ->
	    VAR_FPREFIX(avgaux1)(Matches,X1,X2,Avg,Warning)

	  ; VAR_FPREFIX(var_exists)(G) ->
	    findall(Grp, member(flora_rslt(_,Grp), Matches), L),
	    sort(L,Groups),
	    member(G,Groups),
	    findall(D, member(flora_rslt(D,G), Matches), DL),
	    VAR_FPREFIX(avgaux1)(DL,X1,X2,Avg,Warning)

	  ;
	    VAR_FPREFIX(avgaux2)(L,X1,X2,Avg,Warning)
	),
	( var(Warning) ->
	    true
	  ;
	    STD_FPREFIX(warning_nl)('discarding non-numeric objects while computing average')
	).

VAR_FPREFIX(avgaux1)([],S,N,Avg,_) :-
	(var(S) -> fail ; Avg is S/N).

VAR_FPREFIX(avgaux1)([H|T],X1,X2,Avg,Warning) :-
	( number(H) ->
	    (var(X1) -> S=H, N=1 ; S is X1+H, N is X2+1),
	    VAR_FPREFIX(avgaux1)(T,S,N,Avg,Warning)

	  ;
	    Warning=warning,
	    VAR_FPREFIX(avgaux1)(T,X1,X2,Avg,_)
	).

VAR_FPREFIX(avgaux2)([],S,N,Avg,_) :-
	(var(S) -> fail ; Avg is S/N).

VAR_FPREFIX(avgaux2)([flora_rslt(D,_)|T],X1,X2,Avg,Warning) :-
	( number(D) ->
	    (var(X1) -> S=D, N=1 ; S is X1+D, N is X2+1),
	    VAR_FPREFIX(avgaux2)(T,S,N,Avg,Warning)

	  ;
	    Warning=warning,
	    VAR_FPREFIX(avgaux2)(T,X1,X2,Avg,_)
	).


/****************************************************************************/
VAR_FPREFIX(count)(G,Matches,Count) :-
	( VAR_FPREFIX(var_exists)(G) ->
	    findall(Grp, member(flora_rslt(_,Grp), Matches), L),
	    sort(L,Groups),
	    member(G,Groups),
	    findall(D, member(flora_rslt(D,G), Matches), DL),
	    length(DL,Count)

	  ;
	    length(Matches,Count)
	).


/****************************************************************************/
VAR_FPREFIX(collectset)(G,Matches,Set) :-
	( G = nogrp ->
	    sort(Matches,Set)

	  ; VAR_FPREFIX(var_exists)(G) ->
	    findall(Grp, member(flora_rslt(_,Grp), Matches), L),
	    sort(L,Groups),
	    member(G,Groups),
	    findall(D, member(flora_rslt(D,G), Matches), DL),
	    sort(DL,Set)

	  ;
	    findall(D, member(flora_rslt(D,G), Matches), DL),
	    sort(DL,Set)
	).


/****************************************************************************/
VAR_FPREFIX(collectbag)(G,Matches,Bag) :-
	( G = nogrp ->
	    Bag=Matches

	  ; VAR_FPREFIX(var_exists)(G) ->
	    findall(Grp, member(flora_rslt(_,Grp), Matches), L),
	    sort(L,Groups),
	    member(G,Groups),
	    findall(D, member(flora_rslt(D,G), Matches), Bag)

	  ;
	    findall(D, member(flora_rslt(D,G), Matches), Bag)
	).


/****************************************************************************/
VAR_FPREFIX(var_exists)(X) :- var(X), !.

VAR_FPREFIX(var_exists)(T) :-
	functor(T,_,N),
	VAR_FPREFIX(var_exists)(T,N).

VAR_FPREFIX(var_exists)(T,N) :-
	N>=1,
	arg(N,T,Arg),
	( VAR_FPREFIX(var_exists)(Arg) ->
	    !
	  ;
	    M is N-1,
	    VAR_FPREFIX(var_exists)(T,M)
	).


/***********************  End of flraggregate.P  *********************/
/*** closure/flrtrailer0.P: appended automatically by the FLORA compiler
     to STATIC code when equality maintenance is DISABLED 
 ***/


#undef VAR_FPREFIX_BASE
#include "flora_prefix.h"
#include "flora_trailer.h"


/*****************************************************************************
  complementary rules to protect against "undefined" error reported by XSB 
*****************************************************************************/
VAR_FPREFIX(fd)(_,_,_)   :- fail.
VAR_FPREFIX(mvd)(_,_,_)  :- fail.
VAR_FPREFIX(ifd)(_,_,_)  :- fail.
VAR_FPREFIX(imvd)(_,_,_) :- fail.
VAR_FPREFIX(fs)(_,_,_)   :- fail.
VAR_FPREFIX(mvs)(_,_,_)  :- fail.
VAR_FPREFIX(sub)(_,_)    :- fail.
VAR_FPREFIX(isa)(_,_)    :- fail.


/****************************  End of Trailer  ******************************/

