package dfki.protege.flora_tab;

import java.util.*;
import java.io.*;

public class ExternalInference {

  Process process;
  BufferedReader inputStream;
  PrintWriter outputStream;

  public ExternalInference(String command[], boolean useStdError) 
         throws Exception {
    process = Runtime.getRuntime().exec(command);
    outputStream = new PrintWriter(process.getOutputStream(), true);
    InputStream is;
    if (useStdError)
      is = process.getErrorStream();
    else
      is = process.getInputStream();
    inputStream = new BufferedReader(new InputStreamReader(is));
  }

  StringBuffer dialogue(String command, String expected) throws Exception {
    tell(command);
    StringBuffer answer = expect(expected);
    return answer;
  }

  void tell(String tellString) {
    outputStream.println(tellString);
    // System.out.println("told: " + tellString);
  }

  StringBuffer expect(String expected) throws Exception {
    StringBuffer buffer = new StringBuffer();
    int len = expected.length();
    char last = expected.charAt(len-1);
    int c;
    while ((c = inputStream.read()) != -1) {
      // System.out.println("read: " + (char)c);
      buffer.append((char)c);
      if (c == last) {
        boolean match = true;
        int blen = buffer.length();
        for (int i = 1; match && (i < len); i++) {
          char expectedChar = expected.charAt(len-1-i);
          int bpos = blen-1-i;
          if (bpos < 0)
            match = false;
          char bufferChar = buffer.charAt(bpos);
          if (expectedChar != bufferChar)
            match = false;
        }

        if (match) return buffer;

      }

    }

    return null;

  }


}


